<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-col :span="6">
        <el-form-item label="审批阅卷" prop="testName" label-width="100px">
          <el-input v-model="queryParams.testName" placeholder="请输入试卷名称搜索" clearable :disabled="disabled" />
        </el-form-item>
      </el-col>

      <el-col :span="6">
        <el-form-item label="班级" prop="classId">
          <div style="width: 60%;">
            <treeselect ref="refSelect" :multiple="multiple" :disabled="disabled" />
          </div>
        </el-form-item>
      </el-col>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['school-paper:testPaperRecord:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['school-paper:testPaperRecord:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['school-paper:testPaperRecord:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['school-paper:testPaperRecord:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row> -->

    <el-table v-if="typePaper == 1" v-loading="loading" :data="testPaperRecordList"
      @selection-change="handleSelectionChange">
      <!-- <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="主键id" align="center" prop="id" v-if="true"/> -->
      <el-table-column label="试卷名称" prop="testName" />
      <el-table-column label="满分" prop="totalPoints" />
      <el-table-column label="班级" prop="phaseClass" />
      <!-- <el-table-column label="总得分" align="center" prop="totalPoints" />
      <el-table-column label="备注" align="center" prop="remark" /> -->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button type="primary" size="medium" @click="examination(scope.row)">批卷</el-button>

          <!-- <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['school-paper:testPaperRecord:remove']"
          >删除</el-button> -->
        </template>
      </el-table-column>
    </el-table>
    <el-table v-if="typePaper == 2" v-loading="loading" :data="testPaperRecordList"
      @selection-change="handleSelectionChange">
      <!-- <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="主键id" align="center" prop="id" v-if="true"/> -->
      <el-table-column label="同学名称" prop="nickName" />
      <el-table-column label="班级" prop="phaseClass" />
      <el-table-column label="得分" prop="totalPoints" />
      <!-- <el-table-column label="总得分" align="center" prop="totalPoints" />
      <el-table-column label="备注" align="center" prop="remark" /> -->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button v-if="scope.row.status == 3" type="success" size="medium"
            @click="handleUpdate(scope.row, 2)">已批卷</el-button>
          <el-button v-else type="primary" size="medium" @click="handleUpdate(scope.row, 1)">批卷</el-button>

        </template>
        <!-- <template slot-scope="scope" v-if="scope.row.status == 1 || scope.row.status == 2">
        </template> -->
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改答题记录对话框 -->
    <el-dialog :title="title" :visible.sync="open" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <!-- <el-form-item label="题目" prop="userId">
          <editor v-model="form.topic" :min-height="192" :iconType="['image']" />
        </el-form-item>
        <el-form-item label="答案" prop="testPaperId">
          <el-input type="textarea" :rows="2" placeholder="请输入内容" v-model="form.answer">
          </el-input>
        </el-form-item>
        <el-form-item label="图片" prop="remark">
          <el-image style="width: 100px; height: 100px" :src="form.answerPic">
          </el-image>
        </el-form-item>
        <el-form-item label="分数" prop="totalPoints">
          <el-input v-model="form.score" placeholder="请输入总得分" />
        </el-form-item>
        <el-form-item label="优秀答案" prop="totalPoints">
          <el-switch v-model="form.good" active-color="#13ce66" inactive-color="#ff4949">
          </el-switch>
        </el-form-item> -->
        <!-- <el-col :span="18"> -->
        <el-form-item label="题目" prop="topic">
          <editor v-model="form.topic" :min-height="192" :iconType="['image']" :readOnly="true" />
        </el-form-item>
        <template v-if="[1, '1', 3, '3'].includes(form.species)">
          <el-form-item label="答案" prop="answer">
            <editor v-model="form.answer" :min-height="192" :iconType="['image']" :readOnly="true" />
          </el-form-item>
          <el-form-item label="答案图片" prop="answerPic">
            <imageUpload :limit="9" v-model="form.answerPic" :disabled="true" />
          </el-form-item>
        </template>
        <template v-if="[2, '2'].includes(form.species)">
          <el-form-item label="选项" prop="options">
            <div class="app-container-form-check">
              <i class="el-icon-circle-plus-outline app-container-form-check-add"
                v-if="!form.options || !form.options.length" @click="clickAddCheckList"></i>
              <div v-for="(item, index) in form.options" :key="index" class="app-container-form-check-item">
                <span class="app-container-form-check-item-type">{{
                  index | filterType(form.options)
                }}</span><i v-if="index + 1 === form.options.length"
                  class="el-icon-circle-plus-outline app-container-form-check-item-add"></i>
                <i class="el-icon-remove-outline app-container-form-check-item-del" v-else></i>
                <editor v-model="item.optionContent" :min-height="192" :iconType="['image']" :readOnly="true" />
              </div>
            </div>
          </el-form-item>
          <el-form-item label="标准答案" prop="correctAnswer" v-if="form.options && form.options.length">
            <el-radio-group v-model="form.correctAnswer">
              <el-radio :label="item.optionTag" v-for="(item, index) in form.options" :key="index" disabled>{{ index |
                filterType(form.options) }}</el-radio>
            </el-radio-group>
          </el-form-item>
        </template>
        <!-- <el-form-item label="典例精讲" prop="type">
          <el-switch @change="changeExplain" v-model="form.type" active-color="#409eff">
          </el-switch>
        </el-form-item>
        <template v-if="form.type">
          <el-form-item label="解答过程" prop="resolveCourse">
            <editor v-model="form.resolveCourse" :min-height="192" :iconType="['image']" />
          </el-form-item>
          <el-form-item label="解答视频" prop="resolveVideo">
            <fileUpload v-model="form.resolveVideo" :limit="1" ref="refFileupload" :value="form.resolveVideo"
              :fileSize="1024" :fileType="['mp4', 'mp3']" />
          </el-form-item>
        </template> -->
        <!-- </el-col> -->
        <el-form-item label="分数" prop="score">
          <el-input-number v-model="form.score" placeholder="请输入总得分" :disabled="reviewed" :max="form.topicScore"
            :min="0" />
        </el-form-item>
        <el-form-item label="优秀答案" prop="good">
          <el-switch v-model="form.good" active-color="#13ce66" inactive-color="#ff4949" :disabled="reviewed">
          </el-switch>
        </el-form-item>
      </el-form>
      <div class="btnColor">
        <div slot="footer" class="dialog-footer" style="text-align: left;" v-if="query.pageNum > 1 && pages > 1">
          <el-button :loading="buttonLoading" type="primary" @click="justQuestion(form)">上 一 题</el-button>
        </div>
        <div slot="footer" class="dialog-footer" style="text-align: left;margin-left: 20px;"
          v-if="query.pageNum != pages">
          <el-button :loading="buttonLoading" type="primary" @click="nextQuestion(form)">下 一 题</el-button>
        </div>
        <div slot="footer" class="dialog-footer" style="text-align: left;margin-left: 20px;"
          v-if="query.pageNum == pages && reviewed == false">
          <el-button :loading="buttonLoading" type="primary" @click="clickComplete(form)">批 卷 完 成</el-button>
        </div>
      </div>

    </el-dialog>
  </div>
</template>

<script>
import { listTestPaperRecord, getTestPaperRecord, delTestPaperRecord, addTestPaperRecord, updateTestPaperRecord, listgetClassList, completeReadOver } from "@/api/school-paper/testPaperRecord";
import {
  getPhaseList
} from "@/api/school-paper/questionBank";
import Treeselect from "./components/treeselect.vue"

export default {
  name: "TestPaperRecord",
  components: { Treeselect },
  data() {
    return {
      url: 'https://fuss10.elemecdn.com/e/5d/4a731a90594a4af544c0c25941171jpeg.jpeg',
      srcList: [
        'https://fuss10.elemecdn.com/8/27/f01c15bb73e1ef3793e64e6b7bbccjpeg.jpeg',
        'https://fuss10.elemecdn.com/1/8e/aeffeb4de74e2fde4bd74fc7b4486jpeg.jpeg'
      ],
      textarea: '',
      disabled: false,
      reviewed: false,
      PhaseList: [], // 阶段
      value: '',
      fdsa: 4,
      typePaper: 1,
      // 按钮loading
      buttonLoading: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 答题记录表格数据
      testPaperRecordList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        testName: undefined,
      },
      pages: 0,// 总页码
      query: {
        pageNum: 1,
        pageSize: 1,
      },
      classId: '',
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        score: [
          { required: true, message: "总得分不能为空", trigger: "blur" }
        ],
        // good: [
        //   { required: true, message: "用户id不能为空", trigger: "blur" }
        // ],
      }
    };
  },
  filters: {
    filterType(val, list) {
      if (val >= 0) {
        let arr = [
          "A",
          "B",
          "C",
          "D",
          "E",
          "F",
          "G",
          "H",
          "I",
          "J",
          "K",
          "L",
          "M",
          "N",
          "O",
          "P",
          "Q",
          "R",
          "S",
          "T",
          "U",
          "V",
          "W",
          "X",
          "Y",
          "Z",
        ];
        return arr[val];
      } else {
        return val;
      }
    },
  },
  created() {
    this.$nextTick(() => {
      this.getList();

    })
    this.questionType()
  },
  methods: {
    justQuestion(val) {
      this.query.pageNum--
      this.handleUpdate(val)
    },
    nextQuestion(val) {
      let self = this
      if (this.reviewed == false) {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (self.query.pageNum < self.pages) {
              let good
              if (self.form.good == true) {
                good = 0
              } else {
                good = 1
              }
              let params = {
                id: val.id,
                score: self.form.score,
                good: good
              }
              updateTestPaperRecord(params).then(response => {
                if (response.code == 200) {
                  self.query.pageNum++
                  self.handleUpdate(val)
                }
              })
            }
          }
        });
      } else {
        if (self.query.pageNum < self.pages) {
          self.query.pageNum++
          self.handleUpdate(val)
        }
      }
    },
    clickComplete(val) {
      let self = this
      // this.nextQuestion(val)

      // return
      this.$refs["form"].validate(valid => {
        if (valid) {
          let good
          if (self.form.good == true) {
            good = 0
          } else {
            good = 1
          }
          let params = {
            id: val.id,
            score: self.form.score,
            good: good
          }
          updateTestPaperRecord(params).then(response => {
            if (response.code == 200) {
              completeReadOver({ id: self.form.recordId }).then((res) => {
                self.open = false;
                self.$modal.msgSuccess("批卷完成");
                self.getList();
              })
            }
          })
        }
      });
    },
    // 典例精讲
    changeExplain(e) {
      let self = this;
      if (e) {
        self.$refs.form.clearValidate();
        self.initleRules();
        self.isExplan(e);
        self.isSpec(self.form.species);
      }
    },
    // 选项
    clickAddCheckList() {
      if (this.form.options && !this.form.options.length) {
        this.form.options.unshift({
          optionContent: "",
        });
      }
    },
    // 阶段
    questionType() {
      getPhaseList().then((res) => {
        this.PhaseList = res.data
      })
    },
    // 批卷
    examination(val) {
      if (val) {
        this.classId = val.classId
        this.queryParams.pageNum = 1
      }
      // this.resetQuery()
      // let classId = this.$refs['refSelect'].value
      // console.log(val,'val-------')
      let params = {
        ...this.queryParams,
        classId: this.classId
      }
      listgetClassList(params).then(response => {
        this.testPaperRecordList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
      this.disabled = true
      this.$refs['refSelect'].value = undefined
      this.resetForm("queryForm");
      this.typePaper = 2
    },
    /** 查询答题记录列表 */
    getList() {
      if (this.typePaper == 2) {
        this.examination()
      } else {
        this.loading = true;
        let classId = this.$refs['refSelect'].value ? this.$refs['refSelect'].value : ''
        let params = {
          ...this.queryParams,
          classId: classId
        }
        listTestPaperRecord(params).then(response => {
          this.testPaperRecordList = response.rows;
          this.total = response.total;
          this.loading = false;
        });
      }
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        topic: undefined,
        answer: undefined,
        answerPic: undefined,
        score: undefined,
        goodsAnswers: undefined,
        good: undefined,
        correctAnswer: undefined
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.$refs['refSelect'].value = undefined
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      // this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加答题记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row, val) {
      let titlesiz = '正在批改'
      if (val == 1) {
        this.reviewed = false
        titlesiz = '正在批改'
        this.query.pageNum = 1
      } else if (val == 2) {
        this.reviewed = true
        titlesiz = '正在查看'
        this.query.pageNum = 1
      }
      let self = this
      self.loading = true;
      let params = {
        recordId: row.recordId,
        ...self.query,
      }
      getTestPaperRecord(params).then(response => {
        self.loading = false;
        if (response.rows.length && response.rows) {
          self.$nextTick(() => {
            self.form = response.rows[0];
            self.form.topicScore = Number(self.form.topicScore)
            if (self.form.answerPic) {
              let arr = self.form.answerPic.split(','),
                brr = [];
              arr.forEach((item) => {
                brr.push({
                  url: item
                })
              })
              self.form.answerPic = brr
            }
            if (self.form.good == 1) {
              self.form.good = false
            } else if (self.form.good == 0) {
              self.form.good = true
            }
            self.title = titlesiz + self.form.studentName + "的" + '（' + self.form.testName + '）' + '试卷';
            // self.$set(self.form, 'rightAnswers', 3)
            self.open = true;
          })
        } else {
          self.$modal.msgSuccess("暂无数据");
        }

        self.pages = response.pages
        // self.title = "正在批改 同学1 的（期中模考试卷1套）试卷";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.buttonLoading = true;
          if (this.form.id != null) {
            updateTestPaperRecord(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          } else {
            addTestPaperRecord(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除答题记录编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true;
        return delTestPaperRecord(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      let classId = this.$refs['refSelect'].value
      this.download('school-paper/testPaperRecord/export', {
        ...this.queryParams, classId: classId
      }, `testPaperRecord_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
<style lang="scss" scoped>
.btnColor {
  display: flex;
}

.app-container {
  &-list {
    padding: 20px 40px;
    display: flex;
    flex-wrap: wrap;
    // justify-content: space-between;

    &-item {
      padding: 15px 20px;
      width: calc(33% - 40px);
      border-radius: 5px;
      background-color: #f1efef;
      margin-bottom: 20px;
      margin-right: 10px;

      &-title {
        font-size: 18px;
        margin-bottom: 10px;
      }

      &-html {
        font-size: 16px;
        margin-bottom: 20px;
        word-break: break-all;
        text-overflow: ellipsis;
        display: -webkit-box;
        -webkit-box-orient: vertical;
        -webkit-line-clamp: 3;
        /* 超出几行省略 */
        overflow: hidden;
      }

      &-footer {
        display: flex;
        justify-content: right;

        button {
          background: transparent;
          border: none;
        }

        button::after {
          border: none;
        }
      }
    }

    // &-item:last-child {
    //   margin-bottom: 0px;
    // }
  }



  &-form {
    height: 60vh;
    overflow-x: hidden;
    overflow-y: auto;

    &-check {
      &-add {
        font-size: 30px;
        color: #409eff;
        cursor: pointer;
      }

      &-item {
        margin-bottom: 12px;

        &-type {
          display: inline-block;
          padding: 8px 15px;
          border: 1px solid #eeecec;
          font-size: 16px;
          line-height: 16px;
          border-radius: 5px;
          margin: 0px 12px 15px 0px;
        }

        &-add,
        &-del {
          font-size: 25px;
          cursor: pointer;
        }

        &-add {
          color: #409eff;
        }

        &-del {
          color: #f56c6c;
        }
      }

      &-item:last-child {
        margin-bottom: 0rpx;
      }
    }
  }
}

::v-deep .el-form-item__content {
  width: 100%;
  margin-left: 0px !important;
}

::v-deep .el-form-item {
  display: flex
}
</style>